/**************************************************************
 * HTTPPrint.h
 * Provides callback headers and resolution for user's custom
 * HTTP Application.
 * 
 * This file is automatically generated by the MPFS Utility
 * ALL MODIFICATIONS WILL BE OVERWRITTEN BY THE MPFS GENERATOR
 **************************************************************/

#ifndef __HTTPPRINT_H
#define __HTTPPRINT_H

#include "TCPIP Stack/TCPIP.h"

#if defined(STACK_USE_HTTP2_SERVER)

extern HTTP_CONN curHTTP;
extern HTTP_STUB httpStubs[MAX_HTTP_CONNECTIONS];
extern BYTE curHTTPID;

void HTTPPrint(DWORD callbackID);
void HTTPPrint_config_mac(void);
void HTTPPrint_config_ip(void);
void HTTPPrint_dhcp_sw(void);
void HTTPPrint_config_subnet(void);
void HTTPPrint_config_gw(void);
void HTTPPrint_config_dns1(void);
void HTTPPrint_config_dns2(void);
void HTTPPrint_config_ip_port(WORD);
void HTTPPrint_tcp_sw(WORD);
void HTTPPrint_dir_checked(WORD,WORD);
void HTTPPrint_GetMaxLengthPortName(void);
void HTTPPrint_PortName(WORD);
void HTTPPrint_vref_checked(WORD,WORD);
void HTTPPrint_auth_onoff(void);
void HTTPPrint_GetMaxLengthAuth(void);
void HTTPPrint_Password(WORD);
void HTTPPrint_PasswordResult(void);
void HTTPPrint_GetMaxLengthNTP(void);
void HTTPPrint_NTPserver(void);
void HTTPPrint_BoardVersion(void);
void HTTPPrint_AnalogTRIS(WORD);
void HTTPPrint_AnalogInput(WORD);
void HTTPPrint_DigitalTRIS(WORD);
void HTTPPrint_DigitalPORT(WORD,WORD);
void HTTPPrint_DigitalSwDisabled(WORD);
void HTTPPrint_LCDline(WORD);

void HTTPPrint(DWORD callbackID)
{
	switch(callbackID)
	{
        case 0x00000000:
			HTTPPrint_config_mac();
			break;
        case 0x00000001:
			HTTPPrint_config_ip();
			break;
        case 0x00000002:
			HTTPPrint_dhcp_sw();
			break;
        case 0x00000003:
			HTTPPrint_config_subnet();
			break;
        case 0x00000004:
			HTTPPrint_config_gw();
			break;
        case 0x00000005:
			HTTPPrint_config_dns1();
			break;
        case 0x00000006:
			HTTPPrint_config_dns2();
			break;
        case 0x00000007:
			HTTPPrint_config_ip_port(0);
			break;
        case 0x00000008:
			HTTPPrint_config_ip_port(1);
			break;
        case 0x00000009:
			HTTPPrint_tcp_sw(0);
			break;
        case 0x0000000a:
			HTTPPrint_config_ip_port(2);
			break;
        case 0x0000000b:
			HTTPPrint_tcp_sw(1);
			break;
        case 0x0000000c:
			HTTPPrint_config_ip_port(3);
			break;
        case 0x0000000d:
			HTTPPrint_tcp_sw(2);
			break;
        case 0x0000000e:
			HTTPPrint_config_ip_port(4);
			break;
        case 0x0000000f:
			HTTPPrint_tcp_sw(3);
			break;
        case 0x00000010:
			HTTPPrint_dir_checked(0,TRUE);
			break;
        case 0x00000011:
			HTTPPrint_dir_checked(0,FALSE);
			break;
        case 0x00000012:
			HTTPPrint_dir_checked(1,TRUE);
			break;
        case 0x00000013:
			HTTPPrint_dir_checked(1,FALSE);
			break;
        case 0x00000014:
			HTTPPrint_dir_checked(2,TRUE);
			break;
        case 0x00000015:
			HTTPPrint_dir_checked(2,FALSE);
			break;
        case 0x00000016:
			HTTPPrint_dir_checked(3,TRUE);
			break;
        case 0x00000017:
			HTTPPrint_dir_checked(3,FALSE);
			break;
        case 0x00000018:
			HTTPPrint_dir_checked(4,TRUE);
			break;
        case 0x00000019:
			HTTPPrint_dir_checked(4,FALSE);
			break;
        case 0x0000001a:
			HTTPPrint_dir_checked(5,TRUE);
			break;
        case 0x0000001b:
			HTTPPrint_dir_checked(5,FALSE);
			break;
        case 0x0000001c:
			HTTPPrint_dir_checked(6,TRUE);
			break;
        case 0x0000001d:
			HTTPPrint_dir_checked(6,FALSE);
			break;
        case 0x0000001e:
			HTTPPrint_dir_checked(7,TRUE);
			break;
        case 0x0000001f:
			HTTPPrint_dir_checked(7,FALSE);
			break;
        case 0x00000020:
			HTTPPrint_dir_checked(8,TRUE);
			break;
        case 0x00000021:
			HTTPPrint_dir_checked(8,FALSE);
			break;
        case 0x00000022:
			HTTPPrint_dir_checked(9,TRUE);
			break;
        case 0x00000023:
			HTTPPrint_dir_checked(9,FALSE);
			break;
        case 0x00000024:
			HTTPPrint_dir_checked(10,TRUE);
			break;
        case 0x00000025:
			HTTPPrint_dir_checked(10,FALSE);
			break;
        case 0x00000026:
			HTTPPrint_dir_checked(11,TRUE);
			break;
        case 0x00000027:
			HTTPPrint_dir_checked(11,FALSE);
			break;
        case 0x00000028:
			HTTPPrint_dir_checked(12,TRUE);
			break;
        case 0x00000029:
			HTTPPrint_dir_checked(12,FALSE);
			break;
        case 0x0000002a:
			HTTPPrint_dir_checked(13,TRUE);
			break;
        case 0x0000002b:
			HTTPPrint_dir_checked(13,FALSE);
			break;
        case 0x0000002c:
			HTTPPrint_dir_checked(14,TRUE);
			break;
        case 0x0000002d:
			HTTPPrint_dir_checked(14,FALSE);
			break;
        case 0x0000002e:
			HTTPPrint_dir_checked(15,TRUE);
			break;
        case 0x0000002f:
			HTTPPrint_dir_checked(15,FALSE);
			break;
        case 0x00000030:
			HTTPPrint_GetMaxLengthPortName();
			break;
        case 0x00000031:
			HTTPPrint_PortName(0);
			break;
        case 0x00000032:
			HTTPPrint_PortName(1);
			break;
        case 0x00000033:
			HTTPPrint_PortName(2);
			break;
        case 0x00000034:
			HTTPPrint_PortName(3);
			break;
        case 0x00000035:
			HTTPPrint_PortName(4);
			break;
        case 0x00000036:
			HTTPPrint_PortName(5);
			break;
        case 0x00000037:
			HTTPPrint_PortName(6);
			break;
        case 0x00000038:
			HTTPPrint_PortName(7);
			break;
        case 0x00000039:
			HTTPPrint_PortName(8);
			break;
        case 0x0000003a:
			HTTPPrint_PortName(9);
			break;
        case 0x0000003b:
			HTTPPrint_PortName(10);
			break;
        case 0x0000003c:
			HTTPPrint_PortName(11);
			break;
        case 0x0000003d:
			HTTPPrint_PortName(12);
			break;
        case 0x0000003e:
			HTTPPrint_PortName(13);
			break;
        case 0x0000003f:
			HTTPPrint_PortName(14);
			break;
        case 0x00000040:
			HTTPPrint_PortName(15);
			break;
        case 0x00000041:
			HTTPPrint_PortName(16);
			break;
        case 0x00000042:
			HTTPPrint_PortName(17);
			break;
        case 0x00000043:
			HTTPPrint_PortName(18);
			break;
        case 0x00000044:
			HTTPPrint_PortName(19);
			break;
        case 0x00000045:
			HTTPPrint_PortName(20);
			break;
        case 0x00000046:
			HTTPPrint_PortName(21);
			break;
        case 0x00000047:
			HTTPPrint_PortName(22);
			break;
        case 0x00000048:
			HTTPPrint_PortName(23);
			break;
        case 0x00000049:
			HTTPPrint_vref_checked(0,TRUE);
			break;
        case 0x0000004a:
			HTTPPrint_vref_checked(0,FALSE);
			break;
        case 0x0000004b:
			HTTPPrint_vref_checked(1,TRUE);
			break;
        case 0x0000004c:
			HTTPPrint_vref_checked(1,FALSE);
			break;
        case 0x0000004d:
			HTTPPrint_auth_onoff();
			break;
        case 0x0000004e:
			HTTPPrint_GetMaxLengthAuth();
			break;
        case 0x0000004f:
			HTTPPrint_Password(2);
			break;
        case 0x00000050:
			HTTPPrint_Password(0);
			break;
        case 0x00000051:
			HTTPPrint_Password(1);
			break;
        case 0x00000052:
			HTTPPrint_PasswordResult();
			break;
        case 0x00000053:
			HTTPPrint_GetMaxLengthNTP();
			break;
        case 0x00000054:
			HTTPPrint_NTPserver();
			break;
        case 0x00000055:
			HTTPPrint_BoardVersion();
			break;
        case 0x00000056:
			HTTPPrint_AnalogTRIS(0);
			break;
        case 0x00000057:
			HTTPPrint_AnalogInput(0);
			break;
        case 0x00000058:
			HTTPPrint_AnalogTRIS(1);
			break;
        case 0x00000059:
			HTTPPrint_AnalogInput(1);
			break;
        case 0x0000005a:
			HTTPPrint_AnalogTRIS(2);
			break;
        case 0x0000005b:
			HTTPPrint_AnalogInput(2);
			break;
        case 0x0000005c:
			HTTPPrint_AnalogTRIS(3);
			break;
        case 0x0000005d:
			HTTPPrint_AnalogInput(3);
			break;
        case 0x0000005e:
			HTTPPrint_AnalogTRIS(4);
			break;
        case 0x0000005f:
			HTTPPrint_AnalogInput(4);
			break;
        case 0x00000060:
			HTTPPrint_AnalogTRIS(5);
			break;
        case 0x00000061:
			HTTPPrint_AnalogInput(5);
			break;
        case 0x00000062:
			HTTPPrint_AnalogTRIS(6);
			break;
        case 0x00000063:
			HTTPPrint_AnalogInput(6);
			break;
        case 0x00000064:
			HTTPPrint_AnalogTRIS(7);
			break;
        case 0x00000065:
			HTTPPrint_AnalogInput(7);
			break;
        case 0x00000066:
			HTTPPrint_DigitalTRIS(0);
			break;
        case 0x00000067:
			HTTPPrint_DigitalPORT(0,TRUE);
			break;
        case 0x00000068:
			HTTPPrint_DigitalSwDisabled(0);
			break;
        case 0x00000069:
			HTTPPrint_DigitalPORT(0,FALSE);
			break;
        case 0x0000006a:
			HTTPPrint_DigitalTRIS(1);
			break;
        case 0x0000006b:
			HTTPPrint_DigitalPORT(1,TRUE);
			break;
        case 0x0000006c:
			HTTPPrint_DigitalSwDisabled(1);
			break;
        case 0x0000006d:
			HTTPPrint_DigitalPORT(1,FALSE);
			break;
        case 0x0000006e:
			HTTPPrint_DigitalTRIS(2);
			break;
        case 0x0000006f:
			HTTPPrint_DigitalPORT(2,TRUE);
			break;
        case 0x00000070:
			HTTPPrint_DigitalSwDisabled(2);
			break;
        case 0x00000071:
			HTTPPrint_DigitalPORT(2,FALSE);
			break;
        case 0x00000072:
			HTTPPrint_DigitalTRIS(3);
			break;
        case 0x00000073:
			HTTPPrint_DigitalPORT(3,TRUE);
			break;
        case 0x00000074:
			HTTPPrint_DigitalSwDisabled(3);
			break;
        case 0x00000075:
			HTTPPrint_DigitalPORT(3,FALSE);
			break;
        case 0x00000076:
			HTTPPrint_DigitalTRIS(4);
			break;
        case 0x00000077:
			HTTPPrint_DigitalPORT(4,TRUE);
			break;
        case 0x00000078:
			HTTPPrint_DigitalSwDisabled(4);
			break;
        case 0x00000079:
			HTTPPrint_DigitalPORT(4,FALSE);
			break;
        case 0x0000007a:
			HTTPPrint_DigitalTRIS(5);
			break;
        case 0x0000007b:
			HTTPPrint_DigitalPORT(5,TRUE);
			break;
        case 0x0000007c:
			HTTPPrint_DigitalSwDisabled(5);
			break;
        case 0x0000007d:
			HTTPPrint_DigitalPORT(5,FALSE);
			break;
        case 0x0000007e:
			HTTPPrint_DigitalTRIS(6);
			break;
        case 0x0000007f:
			HTTPPrint_DigitalPORT(6,TRUE);
			break;
        case 0x00000080:
			HTTPPrint_DigitalSwDisabled(6);
			break;
        case 0x00000081:
			HTTPPrint_DigitalPORT(6,FALSE);
			break;
        case 0x00000082:
			HTTPPrint_DigitalTRIS(7);
			break;
        case 0x00000083:
			HTTPPrint_DigitalPORT(7,TRUE);
			break;
        case 0x00000084:
			HTTPPrint_DigitalSwDisabled(7);
			break;
        case 0x00000085:
			HTTPPrint_DigitalPORT(7,FALSE);
			break;
        case 0x00000086:
			HTTPPrint_DigitalTRIS(8);
			break;
        case 0x00000087:
			HTTPPrint_DigitalPORT(8,TRUE);
			break;
        case 0x00000088:
			HTTPPrint_DigitalSwDisabled(8);
			break;
        case 0x00000089:
			HTTPPrint_DigitalPORT(8,FALSE);
			break;
        case 0x0000008a:
			HTTPPrint_DigitalTRIS(9);
			break;
        case 0x0000008b:
			HTTPPrint_DigitalPORT(9,TRUE);
			break;
        case 0x0000008c:
			HTTPPrint_DigitalSwDisabled(9);
			break;
        case 0x0000008d:
			HTTPPrint_DigitalPORT(9,FALSE);
			break;
        case 0x0000008e:
			HTTPPrint_DigitalTRIS(10);
			break;
        case 0x0000008f:
			HTTPPrint_DigitalPORT(10,TRUE);
			break;
        case 0x00000090:
			HTTPPrint_DigitalSwDisabled(10);
			break;
        case 0x00000091:
			HTTPPrint_DigitalPORT(10,FALSE);
			break;
        case 0x00000092:
			HTTPPrint_DigitalTRIS(11);
			break;
        case 0x00000093:
			HTTPPrint_DigitalPORT(11,TRUE);
			break;
        case 0x00000094:
			HTTPPrint_DigitalSwDisabled(11);
			break;
        case 0x00000095:
			HTTPPrint_DigitalPORT(11,FALSE);
			break;
        case 0x00000096:
			HTTPPrint_DigitalTRIS(12);
			break;
        case 0x00000097:
			HTTPPrint_DigitalPORT(12,TRUE);
			break;
        case 0x00000098:
			HTTPPrint_DigitalSwDisabled(12);
			break;
        case 0x00000099:
			HTTPPrint_DigitalPORT(12,FALSE);
			break;
        case 0x0000009a:
			HTTPPrint_DigitalTRIS(13);
			break;
        case 0x0000009b:
			HTTPPrint_DigitalPORT(13,TRUE);
			break;
        case 0x0000009c:
			HTTPPrint_DigitalSwDisabled(13);
			break;
        case 0x0000009d:
			HTTPPrint_DigitalPORT(13,FALSE);
			break;
        case 0x0000009e:
			HTTPPrint_DigitalTRIS(14);
			break;
        case 0x0000009f:
			HTTPPrint_DigitalPORT(14,TRUE);
			break;
        case 0x000000a0:
			HTTPPrint_DigitalSwDisabled(14);
			break;
        case 0x000000a1:
			HTTPPrint_DigitalPORT(14,FALSE);
			break;
        case 0x000000a2:
			HTTPPrint_DigitalTRIS(15);
			break;
        case 0x000000a3:
			HTTPPrint_DigitalPORT(15,TRUE);
			break;
        case 0x000000a4:
			HTTPPrint_DigitalSwDisabled(15);
			break;
        case 0x000000a5:
			HTTPPrint_DigitalPORT(15,FALSE);
			break;
        case 0x000000a6:
			HTTPPrint_LCDline(0);
			break;
        case 0x000000a7:
			HTTPPrint_LCDline(1);
			break;
		default:
			// Output notification for undefined values
			TCPPutROMArray(sktHTTP, (ROM BYTE*)"!DEF", 4);
	}

	return;
}

void HTTPPrint_(void)
{
	TCPPut(sktHTTP, '~');
	return;
}

#endif

#endif
