#define __LCDTASK_C


#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "TCPIPConfig.h"
#include "TCPIP Stack/TCPIP.h"
#include "PICNICTask.h"

extern BOOL gDHCPReceive;

void PIOresponce( tRemoteInfo* pInfo, BOOL bAD, BYTE ADch );

static BYTE PhaseGetData( tRemoteInfo* pInfo );
static void lcdCommand( tRemoteInfo* pInfo, BYTE* cmdbuf, BYTE len );

static tRemoteInfo info;

static BYTE cmdpt = 0;
static BYTE cmdbuf[40 + 2];

#if 0
static enum
{
    SM_PRINT = 0,
    SM_COMMAND
} LCDState;

static BOOL bInitialized = FALSE;
static BYTE cmd = 0;
static BYTE count = 0;
static TCP_SOCKET  hSocket;

void LCDTaskA( void )
{
    BYTE        i;
    TCP_SOCKET  MySocket;

    if ( !bInitialized )
    {
        MySocket = TCPOpen( 0, TCP_OPEN_SERVER, AppConfig.LCDPort, TCP_PURPOSE_DEFAULT );
        hSocket = MySocket;
        LCDState = SM_PRINT;
    }
    else
    {
        MySocket = hSocket;
    }

    if ( INVALID_SOCKET == MySocket )
    {
        return;
    }

    bInitialized = TRUE;

    if ( TCPIsGetReady( MySocket ) )
    {
        TCPGet( MySocket, &i );
        cmd <<= 4;
        ++count;

        putcUART( i );
        putrsUART( "\r\n" );

        if ( SM_COMMAND == LCDState )
        {
            i = toupper( i );

            if ( isdigit( i ) )
            {
                i &= 0x0f;
            }
            else if ( isalnum( i ) )
            {
                i -= ('A' - 10);
            }
            else
            {
                i = 0;
            }

            cmd |= i;

            if ( 2 == count )
            {
                LCDCommand( cmd );
                LCDState = SM_PRINT;
                count = 0;
            }
        }
        else
        {
            if ( isprint( i ) )
            {
                LCDData( i );
            }
            else if ( 0x1b == i )
            {
                LCDState = SM_COMMAND;
                count = 0;
                cmd = 0;
            }
        }
    }
    else if ( !TCPIsConnected( MySocket ) )
    {
        //bInitialized = FALSE;
        //MySocket = INVALID_SOCKET;
    }
}
#endif

void InitLCDTask( void )
{
    memset( &info, 0x00, sizeof(tRemoteInfo) );
}

void LCDTask( void )
{
    if ( !info.flags.bInitialized )
    {
        info.port = AppConfig.LCDPort;
        info.mode = MODE_LCD;
        info.flags.stateNum = PHASE_OPEN;

        if ( AppConfig.Flags.bLcdPortIsTcp )
        {
            info.route = ROUTE_IS_TCP;
        }
        else
        {
            info.route = ROUTE_IS_UDP;
        }
/*
        if ( ROUTE_IS_TCP == info.route && TELNET_PORT == info.port )
        {
            info.flags.bAscMode = 1;
        }
*/
        info.flags.bInitialized = 1;
    }

    if ( gDHCPReceive & LCD_DHCP_FLAG )
    {
        info.flags.stateNum = PHASE_CLOSE;
        gDHCPReceive &= ~LCD_DHCP_FLAG;
    }

    switch ( info.flags.stateNum )
    {
    case PHASE_OPEN:
        info.flags.stateNum = PhaseOpen( &info );
        break;
    case PHASE_LISTEN:
        info.flags.stateNum = PhaseListen( &info );
        break;
    case PHASE_CLOSE:
        info.flags.stateNum = PhaseClose( &info );
        break;
    case PHASE_IDLE:
        PhaseGetData( &info );
        break;
    default:
        break;
    }
}


void lcdCommand( tRemoteInfo* pInfo, BYTE* cmdbuf, BYTE len )
{
    if ( len == 0 )
    {
        return;
    }

    switch ( cmdbuf[0] )
    {
        case LCD_PUTSTRING:
            if ( pInfo->flags.bAscMode )
            {
            }
            else
            {
                cmdbuf++;
                len--;
                while( len-- )
                {
                    LCDData( *cmdbuf++ );
                }
                PIOresponce( pInfo, FALSE, 0 );
            }
            break;
        case LCD_LCDCONTROL:
            if ( pInfo->flags.bAscMode )
            {
            }
            else
            {
                cmdbuf++;
                len--;
                LCDCommand( *cmdbuf++ );
                len--;

                while( len-- )
                {
                    LCDData( *cmdbuf++ );
                }
                PIOresponce( pInfo, FALSE, 0 );
            }
            break;
        default:
            break;
    }
}

static BYTE PhaseGetData( tRemoteInfo* pInfo )
{
    BYTE result = PHASE_IDLE;
    BYTE len;

    len = GetArrayFromNetwork( pInfo, cmdbuf, sizeof(cmdbuf) );

    if ( 0 < len )
    {
        if ( !pInfo->flags.bAscMode )
        {
            lcdCommand( pInfo, cmdbuf, len );
        }
        else
        {
            return PHASE_IDLE;
        }
    }

    return result;
}
