#include "TCPIP Stack/TCPIP.h"
#include "MainDemo.h"
#include "MicroWire.h"

static void sendDat( BYTE dat, BYTE cnt );
static BYTE recvDat( BYTE cnt );
static void e2p93c46_delay( void );

void InitMicroWire( void )
{
    // Disable ENC28J60
    ENC_CS_IO = 1;
    ENC_CS_TRIS = 0;

    // Setup Port
    E2P_93C46_CS = 0;
    E2P_93C46_CLK = 0;
    E2P_93C46_DO = 0;

    E2P_93C46_CSTRIS = 0;
    E2P_93C46_CLKTRIS = 0;
    E2P_93C46_DITRIS = 1;
    E2P_93C46_DOTRIS = 0;
}

void ReadMacAddress( BYTE* buff )
{
    Read93C46( buff + 0, 2 );
    Read93C46( buff + 2, 3 );
    Read93C46( buff + 4, 4 );
}

void Read93C46( BYTE* buff, BYTE addr )
{
    E2P_93C46_CS = 1;

    sendDat( 0x80, 1 );                 // StartBit
    sendDat( (addr & 0x3f) | 0x80, 8 ); // Read Command & Address

    buff[1] = recvDat( 8 );
    buff[0] = recvDat( 8 );

    E2P_93C46_CS = 0;
}

static void sendDat( BYTE dat, BYTE cnt )
{
    while ( cnt )
    {
        if ( dat & 0x80 )
        {
            E2P_93C46_DO = 1;
        }
        else
        {
            E2P_93C46_DO = 0;
        }

        // Clock Out
        E2P_93C46_CLK = 1;
        e2p93c46_delay();
        E2P_93C46_CLK = 0;

        dat <<= 1;
        cnt--;
    }
}

static BYTE recvDat( BYTE cnt )
{
    BYTE dat = 0;

    while ( cnt )
    {
        dat <<= 1;

        // Clock Out
        E2P_93C46_CLK = 1;
        e2p93c46_delay();
        E2P_93C46_CLK = 0;

        if ( E2P_93C46_DI )
        {
            dat |= 0x01;
        }
        cnt--;
    }

    return dat;
}

static void e2p93c46_delay( void )
{
   _asm
      BRA  jmp1
jmp1:
      BRA  jmp2 
jmp2:
      NOP
   _endasm
}
